/*
  LMX2330/2331/2332 "Three wire interface" control with Arduino 
  Source:http://www.g8ajn.tv/dlother3.html
  Modified by YO4HFU
  Arduino pins: LE = Pin 9, DATA = Pin 10,  CLK = Pin 11
 */
 
  const unsigned long IF_R = 0x360028; //Calculated by Code Loader 4 software
  const unsigned long IF_N = 0x107C21; //IF_N counter connected to FoLD pin. Divider 1000 P=16
  const unsigned long RF_R = 0x6002A;
  const unsigned long RF_N = 0x1EA3;
  unsigned long DTA;
  int bp;
  const int LE = 9;
  const int DATA = 10;
  const int CLK = 11;

void setup() {       
  pinMode (LE, OUTPUT);  // latch enable
  pinMode (CLK, OUTPUT);  // clock
  pinMode (DATA, OUTPUT);  // data
  
  digitalWrite(LE,LOW);
  digitalWrite(CLK,LOW);

  // to loop for testing uncomment 3 lines below
 // while(true) { // TEST While to loop for scope
    
 DTA = IF_R;    // Send setup parameters
 SendWord();
 
 DTA = IF_N;
 SendWord();
 
 DTA = RF_R;
 SendWord();

 DTA = RF_N;
 SendWord();
  
//delayMicroseconds(2000); // TEST scope delay between groups

// }   // TEST While to keep looping for testing
}



void loop() {  // loop forever
}

int SendWord() {
  
  bp = 22;
  do{
  bp = bp - 1;   //loop through bit positions 22 to 0
  digitalWrite(CLK,LOW); 
  digitalWrite(DATA, bitRead(DTA,bp) ); 
  digitalWrite(CLK,HIGH); 
  }while(bp>0);
  
  digitalWrite(CLK,LOW); 
  digitalWrite(DATA,LOW);

  digitalWrite(LE,HIGH);   // Set LE to latch data
  delayMicroseconds(4);
  digitalWrite(LE,LOW);

}


